config/routes.rb
Rails.application.routes.draw do
  
  namespace :admin do
      resources :chart_presets

      root to: "chart_presets#index"
    end
    
  resources :chart_presets do
    resources :chart_results
  end
  get 'public/index'
  root 'public#index'
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/chart_result.rb
class ChartResult < ApplicationRecord
    belongs_to :chart_preset
    
end

app/controllers/chart_results_controller.rb
class ChartResultsController < ApplicationController
  layout 'dashboard'
  before_action :get_chart_preset
  before_action :set_chart_result, only: %i[ show edit update destroy ]

  require 'datadog_api_client'

  # GET /chart_results or /chart_results.json
  def index
    @chart_results = @chart_preset.chart_results
  end

  # GET /chart_results/1 or /chart_results/1.json
  def show
  end

  # GET /chart_results/new
  def new
    @chart_result = @chart_preset.chart_results.build
    @chart_result.input_title = @chart_preset.title
    @chart_result.input_description = @chart_preset.description_content
  end

  # GET /chart_results/1/edit
  def edit
  end

  # POST /chart_results or /chart_results.json
  def create
    @chart_result = @chart_preset.chart_results.build(chart_result_params)
    @chart_result.response_link = generate_datadog_dashboard
    respond_to do |format|
      if @chart_result.save
        format.html { redirect_to chart_preset_chart_result_path(@chart_preset, @chart_result), notice: "Chart result was successfully created." }
        format.json { render :show, status: :created, location: @chart_result }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @chart_result.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /chart_results/1 or /chart_results/1.json
  def update
    respond_to do |format|
      if @chart_result.update(chart_result_params)
        format.html { redirect_to chart_preset_chart_result_path(@chart_result), notice: "Chart result was successfully updated." }
        format.json { render :show, status: :ok, location: @chart_result }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @chart_result.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /chart_results/1 or /chart_results/1.json
  def destroy
    @chart_result.destroy

    respond_to do |format|
      format.html { redirect_to chart_preset_chart_results_path(@chart_preset), notice: "Chart result was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    def get_chart_preset
      @chart_preset = ChartPreset.find(params[:chart_preset_id])
    end
    
    # Use callbacks to share common setup or constraints between actions.
    def set_chart_result
      @chart_result = @chart_preset.chart_results.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def chart_result_params
      params.require(:chart_result).permit(:response_link, :status, :chart_preset_id, :input_title, :input_description, :branch_name)
    end

    def generate_datadog_dashboard
      api_instance = DatadogAPIClient::V1::DashboardsAPI.new
      # Perform Request
      # response = api_instance.create_dashboard(body)
      body = JSON.parse(@chart_result.chart_preset.instruction_payload)
      # TODO - replace title
      body['title'] = @chart_result.input_title
      body['description'] = @chart_result.input_description
      body['template_variables'].find { |x| x['prefix'] == "@git.branch" }['default'] = @chart_result.branch_name
      response = api_instance.create_dashboard_with_http_info(body)
      return "https://app.datadoghq.com#{response.first.url}"
    end
end

app/helpers/chart_results_helper.rb
module ChartResultsHelper
end

app/views/chart_results/_chart_result.html.erb
<div id="<%= dom_id chart_result %>">
  <div class="flex justify-center">
    <div class="block p-6 rounded-lg shadow-lg bg-white max-w-sm">
      <h5 class="text-gray-900 text-xl leading-tight font-medium mb-2"><%= chart_result.chart_preset.title %></h5>
      <p class="text-gray-700 text-base mb-4">
        <%= chart_result.response_link %>
      </p>
      <%= link_to "View Dashboard", chart_result.response_link, target: "_blank", class: "inline-block px-6 py-2.5 bg-blue-600 text-white font-medium text-xs leading-tight uppercase rounded shadow-md hover:bg-blue-700 hover:shadow-lg focus:bg-blue-700 focus:shadow-lg focus:outline-none focus:ring-0 active:bg-blue-800 active:shadow-lg transition duration-150 ease-in-out" %>
    </div>
  </div>
</div>

app/views/chart_results/_form.html.erb
<%= form_with(model: [@chart_preset, chart_result], class: "contents") do |form| %>
  <% if chart_result.errors.any? %>
    <div id="error_explanation" class="bg-red-50 text-red-500 px-3 py-2 font-medium rounded-lg mt-3">
      <h2><%= pluralize(chart_result.errors.count, "error") %> prohibited this chart_result from being saved:</h2>

      <ul>
        <% chart_result.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="my-5">
    <%= form.label :input_title %>
    <%= form.text_field :input_title, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="my-5">
    <%= form.label :input_description %>
    <%= form.text_field :input_description, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="my-5">
    <%= form.label :branch_name %>
    <%= form.text_field :branch_name, class: "block shadow rounded-md border border-gray-200 outline-none px-3 py-2 mt-2 w-full" %>
  </div>

  <div class="inline">
    <%= form.submit "Create Datadog Dashboard", class: "rounded-lg py-3 px-5 bg-blue-600 text-white inline-block font-medium cursor-pointer" %>
  </div>
<% end %>

app/views/chart_results/edit.html.erb
<div class="mx-auto md:w-2/3 w-full">
  <h1 class="font-bold text-4xl">Editing chart result</h1>

  <%= render "form", chart_result: @chart_result %>

  <%= link_to "Show this chart result", @chart_result, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
  <%= link_to "Back to chart results", chart_results_path, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
</div>

app/views/chart_results/index.html.erb
<div class="w-full">
  <% if notice.present? %>
    <p class="py-2 px-3 bg-green-50 mb-5 text-green-500 font-medium rounded-lg inline-block" id="notice"><%= notice %></p>
  <% end %>

  <div class="flex justify-between items-center">
    <h1 class="font-bold text-4xl">Chart results</h1>
    <%= link_to 'New chart result', new_chart_result_path, class: "rounded-lg py-3 px-5 bg-blue-600 text-white block font-medium" %>
  </div>

  <div id="chart_results" class="min-w-full">
    <%= render @chart_results %>
  </div>
</div>

app/views/chart_results/new.html.erb
<div class="mx-auto md:w-2/3 w-full">
  <h1 class="font-bold text-4xl">New chart result</h1>

  <%= render "form", chart_result: @chart_result %>

  <%= link_to 'Back to Chart Presets', chart_presets_path, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
</div>

app/views/chart_results/show.html.erb
<div class="mx-auto md:w-2/3 w-full flex">
  <div class="mx-auto">
    <% if notice.present? %>
      <p class="py-2 px-3 bg-green-50 mb-5 text-green-500 font-medium rounded-lg inline-block" id="notice"><%= notice %></p>
    <% end %>

    <%= render @chart_result %>
   <br></br>
    <%= link_to 'Back to Chart Presets', chart_presets_path, class: "ml-2 rounded-lg py-3 px-5 bg-gray-100 inline-block font-medium" %>
  </div>
</div>